/*
 * Code by Raúl Armenta Urrutia :D
 */
var UUID='';
var ACCESS_TOKEN='';
var COUNTRY_CODE='';
var AUDIOSOURCE='';
var PHOTOSOURCE='';
var VIDEOSOURCE='';
var UTC;

var DeviceUUID;
var OpSys;
var pushNotification=null;
var intervalUUID;

var open;
var recordsound;
var recorder;
var myRecordInterval;
var recordDur=0;
var playing=false;
var isRecording=false;
var path = window.location.pathname;
path = path.substr( path, path.length - 10 );
var recordSRC='';
var wavesurfer;
var tapsForZoom=0;
var totalURI='';
var waveform;
var fromYab=false;
var openingClue=false;
var reimgtype='';

/*var w=window.innerWidth;
var h=window.innerHeight;
var rem=0;
if(w>h){
    $('html').css({'font-size':'1vh'});
    $('#headLogo').css({'float':'left'});
    $('#headBtn').css({'float':'right'});
    rem=h/100;
}
else{
    $('html').css({'font-size':'1vw'});
    $('#headLogo').css({'float':'none'});
    $('#headBtn').css({'float':'none'});
    rem=w/100;
}*/


var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('backbutton', this.onBackButton, false);
        document.addEventListener('pause', this.onPause, false);
        document.addEventListener('resume', this.onResume, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    onBackButton: function() {
        app.receivedEvent('backbutton');
    },
    onPause: function() {
        app.receivedEvent('pause');
    },
    onResume: function() {
        app.receivedEvent('resume');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        if(id=='pause'){
            //console.log('se sale de la app D:');
            loadNotiNumber();
        }
        if(id=='resume'){
            //console.log('regresa al app');
            loadNotiNumber();
        }
        if(id=='deviceready'){
            //createNotis();
            //deleteNotis();
           
            open = cordova.plugins.disusered.open;
            /*recordsound = new Media(path+'sounds/startrecord.wav', function(){
                //bla bla
            });*/
            var accuracy=false;
            if(device.platform=='iOS'){
                accuracy=true;
            }

            
            navigator.geolocation.getCurrentPosition(function(position) {
                var latitud=position.coords.latitude;
                var longitud=position.coords.longitude;
               
                var apikeymaps = 'AIzaSyCdtw12wIU7fjOEdbK4QjQML_En9Cd0CNM';
                $.get('https://maps.googleapis.com/maps/api/geocode/json?latlng=' + latitud + ',' + longitud + '&result_type=country&key=' + apikeymaps,function(jsondata){
                    /*country=country.replace("\n","");
                    country=country.replace("\r","");
                    country=country.replace(" ","");*/
                    var results = jsondata.results;
                    ////console.log(results);
                    var address_components = results[0].address_components;
                    ////console.log(results[0]);
                    country = address_components[0].short_name;
                    $.getJSON('js/countries.json',function(data){
                        /*//console.log(data);*/
                        for(var x=0;x<data.length;x++){
                            var pais=data[x];
                            var codes=pais.callingCodes;
                            var countryCode=pais.altSpellings;
                            countryCode=countryCode[0];
                            for(var i=0;i<codes.length;i++){
                                var code=codes[i];
                                var attr='';
                                if(countryCode==country){
                                    attr=' selected'
                                }
                                $('#select-country').append('<option value="'+code+'"'+attr+'>'+pais.name+' - (+'+code+')</option>');
                            }
                        }
                    });
                }).fail(function() {
                    $.getJSON('js/countries.json',function(data){
                        /*//console.log(data);*/
                        for(var x=0;x<data.length;x++){
                            var pais=data[x];
                            var codes=pais.callingCodes;
                            var countryCode=pais.altSpellings;
                            countryCode=countryCode[0];
                            for(var i=0;i<codes.length;i++){
                                var code=codes[i];
                                $('#select-country').append('<option value="'+code+'">'+pais.name+' - (+'+code+')</option>');
                            }
                        }
                    });
                  });
            },null,{enableHighAccuracy: accuracy});

            DeviceUUID=device.uuid;
            OpSys=device.platform;
            intervalUUID=setInterval(function(){
                if(UUID!=''){
                    clearInterval(intervalUUID);

                    pushNotification = PushNotification.init({ "android": {"senderID": "870562620478"},"ios": {"alert": "true", "badge": "true", "sound": "true"}, "windows": {} } );
                    pushNotification.on('registration', function(data) {
                        postRetry('https://yabziip.com/push/saver.php',{user_id:UUID,token:data.registrationId,os:OpSys},function(data){
                            //console.log(JSON.stringify(data));
                            /*postRetry('https://yabziip.com/countnotis.php',{user_id:UUID},function(data){
                                var notis=data.total;
                                var t=parseInt(notis);
                                pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, t);
                                if(t!=0){
                                    $('#pushN').html(t);
                                    $('#pushNumber').show();
                                }
                            });*/
                            //addNotis();
                            //getNotis();
                        });/*.fail(function(){
                            hideLoader();
                            alertar('There was an error, try again later');
                        });*/
                    });
                    loadNotiNumber();
                    pushNotification.on('notification', function(data) {
                        data = data.additionalData;
                        setNotis(data.notis);
                        //console.log(data);
                        if(data.tipo=='text' || data.tipo=='photo' || data.tipo=='video' || data.tipo=='audio'){
                            //alertar(data.tipo);
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    if(whereIam=='home'){
                                        $('#header').show();
                                        $('#footer').show();
                                    }
                                    //validateRead(data.id,data.privacy,data.block_type,data.date,data.erase,0,data.password);
                                    pageinbox=1;
                                    loadInbox();
                                    navigate('inbox');
                                    $("#inbox").animate({ scrollTop: 0 }, "fast");
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','Not now']);
                        }else if(data.tipo=='message_readed'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    pageoutbox=1;
                                    loadOutbox();navigate('outbox');
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['Go to Outbox','OK']);
                        }else if(data.tipo=='comment' || data.tipo=='mention_comment'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    openYab(data.id, data.id_comment);
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','OK']);
                        }else if(data.tipo=='mention'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    openYab(data.id);
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','OK']);
                        }else if(data.tipo=='reyab'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    openYab(data.id);
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','OK']);
                        }else if(data.tipo=='friend_request' || data.tipo=='accept_request' || data.tipo=='cancel_request' || data.tipo=='unfriend_request' || data.tipo=='follow'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    load_profile(data.id);
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','OK']);
                        }else if(data.tipo=='follow_request'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    load_profile(data.id);
                                    setAsReaded(data.notiID);
                                }else if(index==2){
                                    showLoader();
                                    postRetry('https://yabziip.com/follow_request.php',{user_id:UUID,access_token:ACCESS_TOKEN,utc_dif:UTC,sender:data.id},function(data){
                                        hideLoader();
                                        if(data.status=='error'){
                                            //deleteDB();
                                            navigator.notification.alert(data.msg, function(){
                                                //location.reload();
                                            }, 'YabZiip', 'OK');
                                        }else{
                                            navigator.notification.alert(data.msg, function(){
                                                //location.reload();
                                            }, 'YabZiip', 'OK');
                                        }
                                    });/*.fail(function(){
                                        hideLoader();
                                        alertar('There was an error, try again later');
                                    });*/
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View Profile','Accept','Cancel']);
                        }else if(data.tipo=='reminder'){
                            //console.log(data.alert);
                            //console.log(data.titulo);
                            navigator.notification.confirm(data.msg, function(index){
                                
                            }, data.titulo, ['OK']);
                        }else if(data.tipo=='yabziip_opened'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    openYab(data.id);
                                    setAsReaded(data.notiID);
                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','OK']);
                        }else if(data.tipo=='clue_received'){
                            navigator.notification.confirm(data.msg, function(index){
                                if(index==1){
                                    //openYab(data.id);
                                    $('#unziip_answerid').val(data.id);
                                    pageallyabs=1;
                                    openingClue=true;
                                    loadAllYabs();
                                    navigate('wall_message');
                                    setAsReaded(data.notiID);
                                    var intWall=setInterval(function(){
                                        if($('#wall_message').is(':visible')){
                                            if($('#unziip-yabziip').is(':hidden')){
                                                $('#wall_message').find('.cont-zipper').trigger('tap');
                                            }else{
                                                //console.log('se abre');
                                                clearInterval(intWall);
                                            }
                                        }
                                    },100);

                                }else{
                                    setAsReaded(data.notiID);
                                }
                            }, data.titulo, ['View','OK']);
                        }
                    });


                }
            }, 100);
        }


        if(id=='keyboardWillShow'){
            Keyboard.shrinkView(false);
        }

        if(id=='backbutton'){
            //console.log('back');
        }

    }
};

app.initialize();

$.fn.animateRotate = function(startAngle, endAngle, duration, easing, complete){
    return this.each(function(){
        var elem = $(this);

        $({deg: startAngle}).animate({deg: endAngle}, {
            duration: duration,
            easing: easing,
            step: function(now){
                elem.css({
                  '-moz-transform':'rotate('+now+'deg)',
                  '-webkit-transform':'rotate('+now+'deg)',
                  '-o-transform':'rotate('+now+'deg)',
                  '-ms-transform':'rotate('+now+'deg)',
                  'transform':'rotate('+now+'deg)'
                });
            },
            complete: complete || $.noop
        });
    });
};


var whereIam='home';



$(document).ready(function(){
    UTC=new Date();
    UTC=UTC.getTimezoneOffset();
    sndeffect = new Audio("sounds/strongbox.wav");
    sndeffect.volume=0.1;
});




function selectOptionMenu(opt){
    //$('#rotate-message').hide();
    if (opt==1) {
        //console.log('al home');
        //navigator.vibrate(400);
        //pageallyabs=1;
        //loadAllYabs();
        //navigate('wall_message');
        //whereIam='wall_message';
        //$("#wall_message").animate({ scrollTop: 0 }, "fast");
    } else if (opt==2) {
        //console.log('al inbox');
        //navigator.vibrate(400);
        //pageinbox=1;
        //loadInbox();
        //navigate('inbox');
        //whereIam='inbox';
        //$("#inbox").animate({ scrollTop: 0 }, "fast");
    } else if (opt==3) {
        //console.log('al outbox');
        //navigator.vibrate(400);
        //pageoutbox=1;
        //loadOutbox();
        //navigate('outbox');
        //whereIam='outbox';
        //$("#outbox").animate({ scrollTop: 0 }, "fast");
    } else if (opt==4) {
        //console.log('al profile');
        //navigator.vibrate(400);  
        //load_profile(UUID);
    } else if (opt==5) {
        //console.log('al message');
        //navigator.vibrate(400);
        //navigate('send_message');
        //whereIam='send_message';
    } else if (opt==6) {
        //console.log('a notificaciones');
        //navigator.vibrate(400);
        //loadAllNotis();
        //navigate('notificationPanel');
        //whereIam='notificationPanel';
        //setNotis(0);
    }
}

