var canvasH=150;
var canvasW=150;
var CentertranslationX = 0;
var CentertranslationY = 0;
var radialMenu = {
    posX: 0,
    posY: 0,
    diameter: 300,
    numberOfOptions: 6,
    graphicAngles: [],
    breakRadians: [],
    optionRadians: [],
    optionSelectorRadians: 1.50,
    relativeSelectionPos: 0,
    selectedOption: -1,
    angle: 0,
    //variables de calculos de angulos
    COAngle: 0,
    MAngle: 0,
    CAngle: 0,
    MCAngle: 0,
    isClicked: false,
    angularMomentum: 0,
    radianMargin: 0,
    AMangle: 0,
    autoMove: false,
    autoMoveDif: 0,
    autoMoveFrames: 15,
    autoMovedFrames: 0,
    isSelected: false,
    PIedgebehavior: false,
    angularMomentumMod: 1,
    angularDecreaseMod: 0.12,
    angularAnulationSensivility: 0.001,
    angularSelectionSensivility: 0.001,
    R: 250,
    B: 200,
    G: 150,
    RM: 0.1,
    BM: 0.1,
    GM: 0.1,

    imageBG: false,
    imageBTN: false,
    imageIcons: [],
    imageIconsSel: [],
    coors:[],

    getHit: function() {
        //para los calculos matematicos se usan las coordenadas reales, calculadas con los metodos esos de abajo
        /*//console.log(mouseX + ' ' + this.getRealX());
        //console.log(mouseY + ' ' + this.getRealY());*/
        if (collidePointCircle(mouseX, mouseY, this.getRealX(), this.getRealY(), this.diameter * 0.4)) {
            return 2;
        } else if (collidePointCircle(mouseX, mouseY, this.getRealX(), this.getRealY(), this.diameter)) {
            return 1;
        }
        return false;
    },
    getSelectedOption: function() {
        this.relativeSelectionPos = this.optionSelectorRadians - this.angle;
        this.relativeSelectionPos -= Math.floor(this.relativeSelectionPos / (Math.PI * 2) + 0.5) * (Math.PI * 2);
        //print("relativeSelectionPos: "+this.relativeSelectionPos);
        for (var i = 0; i < this.numberOfOptions; i++) {
            //print("breakRadiansA: "+this.breakRadians[i]);
            //print("breakRadiansB: "+this.breakRadians[i+1]);
            if (this.relativeSelectionPos >= this.breakRadians[i] && this.relativeSelectionPos < this.breakRadians[i + 1]) {
                return i;
            }
        }
        return this.numberOfOptions - 1;
    },
    initialize: function(optNum,diameter) {
    	this.diameter = diameter;
        this.imageBG = loadImage("assets/img/menu/imageBG.svg");
        this.imageBTN = loadImage("assets/img/menu/marcador.svg");
        this.numberOfOptions = optNum;
        this.optionSelectorRadians = (Math.PI * -1) + radians(90);
        var actualRadian = (Math.PI * -1);
        this.radianMargin = ((Math.PI * 2) / optNum);
        for (var i = 0; i < optNum; i++) {
            /*var assets/img/menu/1=loadImage("assets/img/menu//opc" + (i + 1) + ".png");
            var assets/img/menu/2=loadImage("assets/img/menu//opc" + (i + 1) + "_o.png");*/
            this.imageIcons[(i + 1) < optNum ? i + 1 : 0] = loadImage("assets/img/menu/opc" + (i + 1) + ".png");
            this.imageIconsSel[(i + 1) < optNum ? i + 1 : 0] = loadImage("assets/img/menu/opc" + (i + 1) + "_o.png");
            this.graphicAngles.push(360 / optNum);
            this.breakRadians.push(actualRadian);
            this.optionRadians.push(actualRadian + (this.radianMargin / 2));
            actualRadian = actualRadian + this.radianMargin;
        }
        /*for (var i = 1; i < optNum; i++) {
            this.imageIcons[i] = loadImage("assets/img/menu//opc" + i + ".png");
            this.imageIconsSel[i] = loadImage("assets/img/menu//opc" + i + "_o.png");
       }*/
        this.breakRadians.push(actualRadian);

        /*print("initialize");
        print("radianMargin: "+this.radianMargin);
        print("optionSelectorRadians: "+this.optionSelectorRadians);
        print("numberOfOptions: "+this.numberOfOptions);
        print("graphicAngles: "+this.graphicAngles);
        print("breakRadians: "+this.breakRadians);
        print("optionRadians: "+this.optionRadians);*/
    },
    touchStart: function() {
        ////console.log(this.getHit() + 'click');
        /*//console.log(mouseX + ' ' + this.getRealX());
        //console.log(mouseY + ' ' + this.getRealY());*/
        var going_on = $('#going_on').is(':visible');
        var settings = $('#settings').is(':visible');
        var search = $('#search').is(':visible');
        var terms = $('#terms').is(':visible');
        var privacy = $('#privacy').is(':visible');
        var manual = $('#manual').is(':visible');
        var update_values = $('#update_values').is(':visible');
        var update_username = $('#update_username').is(':visible');
        var update_acctype = $('#update_acctype').is(':visible');
        var loader = $('#loader').is(':visible');
        var register = $('#register').is(':visible');
        var isPrivateOpen = $('#private-profile').is(':visible');
        if (whereIam=='home' && going_on==false && settings==false && search==false && terms==false && privacy==false && manual==false && update_values==false && loader==false && register==false && update_username==false && update_acctype==false && isPrivateOpen==false) {
	        if(this.getHit() != false){
	            if (this.getHit() == 2) {

	                //console.log(this.getHit() + 'click');
	                //alert("la opcion seleccionada es: " + this.selectedOption);
	                var opt = this.selectedOption;
	                if(opt==0) opt=6;
	                selectOptionMenu(opt);
	            } else if (this.getHit() == 1) {
	                /*print("CLICK------------------- ");
	                //console.log(this.getHit() + 'click');*/
	                this.isSelected = false;
	                this.isClicked = true;
	                this.autoMove = false;
	                this.autoMoveDif = 0;
	                this.autoMovedFrames = 0;
	                this.CAngle = this.getRelativeAngle(mouseX, mouseY);
	                this.COAngle = this.angle;
	            } 
	        }
    	}
    },
    touchMove: function() {
        this.MAngle = this.getRelativeAngle(mouseX, mouseY);
        if (this.isClicked) {
            this.MCAngle = (this.CAngle - this.MAngle);
            this.angle = this.COAngle - this.MCAngle;
            //if(this.AMangle == 0 ) this.AMangle = this.angle;
            //else this.AMangle = this.angle - this.AMangle;
        }
        var opt = this.getSelectedOption();
        if(opt==0) opt=6;
        if (opt==1) {
            $('#optSel').val(1);
            $('#selected-option-wheel').html('Home');
        } else if (opt==2) {
            $('#optSel').val(2);
            $('#selected-option-wheel').html('Inbox');
        } else if (opt==3) {
            $('#optSel').val(3);
            $('#selected-option-wheel').html('Outbox');
        } else if (opt==4) {
            $('#optSel').val(4);
            $('#selected-option-wheel').html('Profile');
        } else if (opt==5) {
            $('#optSel').val(5);
            $('#selected-option-wheel').html('New Message');
        } else if (opt==6) {
            $('#optSel').val(6);
            $('#selected-option-wheel').html('Notifications');
        }
    },
    touchEnd: function() {
        if (this.isClicked) {
            this.isClicked = false;
            this.MAngle = 0;
            this.CAngle = 0;
            this.MCAngle = 0;
            //this.normalizeAngle();
            /*this.selectedOption = this.getSelectedOption();
                    var auxangle =  this.optionSelectorRadians - this.optionRadians[this.selectedOption] ;
                    auxangle -= Math.floor( auxangle / (Math.PI*2) + 0.5) * (Math.PI*2);
                    this.angle = auxangle;*/
        }
        ////console.log(this.getSelectedOption());
    },
    draw: function() {
        //para las funciones de dibujo no se usan las coordenadas reales

        this.losePhysics();
        rotate(this.angle);
        image(this.imageBG, -this.diameter / 2, -this.diameter / 2, this.diameter, this.diameter);
        //rotate(this.angle * -1);
        for (var i = 0; i < this.numberOfOptions; i++) {
            auxX = (this.diameter * 0.38) * Math.cos(this.optionRadians[i]);
            auxY = (this.diameter * 0.38) * Math.sin(this.optionRadians[i]);
            auxDiam = this.diameter * 0.2;
            translate(auxX, auxY);
            rotate(-this.angle);
            /*if (this.selectedOption == i && this.angularMomentum==0 && this.autoMove==false) {*/
        	if (this.selectedOption == i) {
                image(this.imageIconsSel[i], ((auxDiam + auxDiam * 0.1) / 2) * -1, ((auxDiam + auxDiam * 0.1) / 2) * -1, auxDiam + auxDiam * 0.1, auxDiam + auxDiam * 0.1);
            } else {
                image(this.imageIcons[i], (auxDiam / 2) * -1, (auxDiam / 2) * -1, auxDiam, auxDiam);
            }
            rotate(this.angle);
            translate(-auxX, -auxY);
            this.coors[i]={
                'diametro': auxDiam,
                'x':(this.diameter/2) + auxX,
                'y':(this.diameter/2) + auxY
            };
        }
        rotate(this.angle * -1);
        auxDiam = this.diameter * 0.5;
        auxDiamY = auxDiam + auxDiam * 0.05;
        if (this.getHit() == 2) {
            auxDiam = this.diameter * 0.55;
            auxDiamY = auxDiam + auxDiam * 0.05;
        }
        image(this.imageBTN, -auxDiam / 2, -((auxDiamY / 2) + auxDiamY * 0.035), auxDiam, auxDiamY);

    },
    rotateColors: function() {
        this.R += this.RM;
        if (this.R > 255 || this.R < 150) this.RM *= -1;
        this.G += this.GM;
        if (this.G > 255 || this.G < 150) this.GM *= -1;
        this.B += this.BM;
        if (this.B > 255 || this.B < 150) this.BM *= -1;
    },
    //calculos de coordenadas reales
    getRealX: function() {
        return this.posX + CentertranslationX;
    },
    getRealY: function() {
        return this.posY + CentertranslationY;
    },
    getRelativeAngle: function(PX, PY) {
        var dx = PX - this.getRealX();
        var dy = PY - this.getRealY();
        var rAngle = Math.atan2(dy, dx);
        return rAngle;
    },
    normalizeAngle: function() {
        this.angle -= Math.floor(this.angle / (Math.PI * 2) + 0.5) * (Math.PI * 2);
    },
    decreaseMomentum: function() {


        var MinDec = 0.0008;
        if (this.angularMomentum < 0) MinDec *= -1;
        if (this.angularMomentum < this.angularAnulationSensivility || this.angularMomentum > (this.angularAnulationSensivility * -1)) {
            this.angularMomentum -= this.angularMomentum * this.angularDecreaseMod + MinDec;
        } else { this.angularMomentum = 0; }

    },
    losePhysics: function() {
        this.normalizeAngle();
        if (!this.isClicked) {
            if (this.angularMomentum != 0) {
                this.angle += this.angularMomentum;
                this.decreaseMomentum();
            }
            if (!this.isSelected && (this.angularMomentum < 0.001 && this.angularMomentum > -0.001)) {
                this.angularMomentum = 0;
                this.selectedOption = this.getSelectedOption();
                this.isSelected = true;
                this.autoMove = true;
                var auxangle = this.optionSelectorRadians - this.optionRadians[this.selectedOption];
                auxangle -= Math.floor(auxangle / (Math.PI * 2) + 0.5) * (Math.PI * 2);
                var auxAngleRotation = ((auxangle - this.angle) * 1);
                if (Math.abs(auxAngleRotation) > (this.radianMargin * 0.60)) {
                    //si la rotacion requerida para llegar al centro es mayor al 60% del angulo radial de las opciones entonces estamos al borde del PI lo que causa una vuelta completa en auto, hay que normalizar la rotacion
                    auxAngleRotation -= Math.floor(auxAngleRotation / (Math.PI * 2) + 0.5) * (Math.PI * 2);
                }
                this.autoMoveDif = auxAngleRotation;

            }

            if (this.autoMove) {

                this.angle += this.autoMoveDif / this.autoMoveFrames;
                this.autoMovedFrames++;
                if (this.autoMovedFrames == this.autoMoveFrames) {
                    this.autoMove = false;
                    this.autoMovedFrames = 0;
                    this.autoMoveDif = 0;
                }
            }
        } else {
            //calcula el momentum angular segun la posicion relativa del angulo al angulo en el frame anterior, esto se hace fuera del touchmove porque ese solo se ejecuta al moverse
            this.angularMomentum = (this.angle - this.AMangle) * this.angularMomentumMod;
            this.AMangle = this.angle;
        }
        this.normalizeAngle();

    },
    printData: function() {
        //console.clear();
        print("------------------------------------");
        print("RUEDITA");
        print("colliding? " + (this.getHit() == 1));
        print("colliding btn? " + (this.getHit() == 2));
        //print("Mouse relative angle: " + this.getRelativeAngle(mouseX,mouseY) );
        print("object angle: " + this.angle);
        print("optionSelectorRadians: " + this.optionSelectorRadians);
        print("relativeSelectionPos: " + this.relativeSelectionPos);
        print("selectedOption: " + this.selectedOption);
        print("selectedOption pos: " + this.optionRadians[this.selectedOption]);
        //print("object-click relative angle: " + this.COAngle );
        print("Move relative angle: " + this.MAngle);
        //print("click relative angle: " + this.MAngle );
        //print("Move-click relative angle: " + this.MCAngle );
    },


};


function setup() {
	/*$('#home').show();*/
    canvasH = $('#wheel').height();
    canvasW = $('#wheel').width();
    /*$('#home').hide();*/
    /*canvasH = $(window).innerHeight();
    canvasH = (canvasH*80)/100;
    canvasW = $(window).innerWidth();
    canvasW = (canvasW*80)/100;*/
    var canvas = createCanvas(canvasW,canvasH);
    // Move the canvas so it's inside our <div id="sketch-holder">.
    canvas.parent('wheel');

    CentertranslationX = canvasW/2;
    CentertranslationY = canvasH/2;

    var diametro = canvasH - (canvasH*0.1);
    radialMenu.initialize(6, diametro);
    /*radialMenu.diameter=canvasH;*/
    //rectMode(CENTER);
    noStroke();
    
    //noLoop();  // Run once and stop
}

function draw() {
    background('rgba(0,0,0, 0)');

    translate(CentertranslationX, CentertranslationY);
    radialMenu.draw();
    //radialMenu.printData();
}

function touchStarted() {
    radialMenu.touchStart();
}

function touchMoved() {
	/*redraw();*/
	/*clear();*/
    radialMenu.touchMove();
}

function touchEnded() {
    radialMenu.touchEnd();
}

function mousePressed(){
    for (var i = 0; i < radialMenu.imageIcons.length; i++) {
        var coors=radialMenu.coors[i];
        var d=dist(mouseX,mouseY,(coors.x + coors.diametro/4),(coors.y + coors.diametro/4));
        if( d < (coors.diametro/2) ){
            ////console.log(d,i,radialMenu.selectedOption);
            var opts=[1,2,3,4,5,0];
            var order=[1,2,3,4,5,0];
            var pos=opts.indexOf(radialMenu.selectedOption);
            var opts2=null;
            if(pos!=0){
                opts2=opts.splice(0,pos);
                opts.append(opts2);
            }else{
                opts2=opts;
            }
            var o=order.indexOf(i);
            var so=opts[o];
            if(so==0) so=6;
            var going_on = $('#going_on').is(':visible');
            var settings = $('#settings').is(':visible');
            var search = $('#search').is(':visible');
            var terms = $('#terms').is(':visible');
            var privacy = $('#privacy').is(':visible');
            var manual = $('#manual').is(':visible');
            var update_values = $('#update_values').is(':visible');
            var update_username = $('#update_username').is(':visible');
            var update_acctype = $('#update_acctype').is(':visible');
            var loader = $('#loader').is(':visible');
            var register = $('#register').is(':visible');
            ////console.log('whereIam',whereIam,'going_on',going_on,'settings',settings,'search',search,'terms',terms,'privacy',privacy,'manual',manual,'update_values',update_values,'loader',loader,'register',register,'update_username',update_username,'update_acctype',update_acctype,);
            if (whereIam=='home' && going_on==false && settings==false && search==false && terms==false && privacy==false && manual==false && update_values==false && loader==false && register==false && update_username==false && update_acctype==false) {
                //alert(so);
                selectOptionMenu(so);
            }

        }
    }
}

Array.prototype.append = function(array)
{
    this.push.apply(this, array)
}
